summaryrefslogtreecommitdiffstats
path: root/etc/rc.d/hostid_save
diff options
context:
space:
mode:
authorpjd <pjd@FreeBSD.org>2009-07-29 05:23:52 +0000
committerpjd <pjd@FreeBSD.org>2009-07-29 05:23:52 +0000
commit2ef0bbd3c7fc67e7baf0a4a9f965ab28f0268895 (patch)
treebb2f6d10d1f0be213d15ebfa8b06ace8086bec75 /etc/rc.d/hostid_save
parent2e73ad7182c6464ec20ef732baee62264e15b2db (diff)
downloadFreeBSD-src-2ef0bbd3c7fc67e7baf0a4a9f965ab28f0268895.zip
FreeBSD-src-2ef0bbd3c7fc67e7baf0a4a9f965ab28f0268895.tar.gz
Currently there is a problem with fscking UFS file systems created on
top of ZVOLs. The problem is that rc.d/fsck runs before rc.d/zfs. The latter makes ZVOLs to appear in /dev/. In such case rc.d/fsck cannot find devfs entry and aborts. We cannot simply move rc.d/zfs before rc.d/fsck, because we first want kern.hostid to be configured (by rc.d/hostid). If we won't wait (hostid will be 0) we can reuse disks which are in use by different systems (eg. in SAN/NAS environment). We also cannot move rc.d/hostid before rc.d/fsck, because rc.d/hostid on first system start stores generated kern.hostuuid in /etc/hostid file, so it needs root file system to be mounted read-write. The fix is to split rc.d/hostid so that rc.d/hostid (which will now run before rc.d/fsck) only generates hostid and sets up sysctls, but doesn't touch root file system and rc.d/hostid_save (which is run after rc.d/root) and only creates /etc/hostid file. With that in place, we can move ZVOL initialization to dedicated rc.d/zvol script which runs before rc.d/fsck. PR: conf/120194 Reported by: James Snow <snow@teardrop.org> Reviewed by: brooks Approved by: re (kib) MFC after: 2 weeks
Diffstat (limited to 'etc/rc.d/hostid_save')
-rwxr-xr-xetc/rc.d/hostid_save29
1 files changed, 29 insertions, 0 deletions
diff --git a/etc/rc.d/hostid_save b/etc/rc.d/hostid_save
new file mode 100755
index 0000000..44e403f
--- /dev/null
+++ b/etc/rc.d/hostid_save
@@ -0,0 +1,29 @@
+#!/bin/sh
+#
+# $FreeBSD$
+#
+
+# PROVIDE: hostid_save
+# REQUIRE: root
+# BEFORE: mountcritlocal
+# KEYWORD: nojail
+
+. /etc/rc.subr
+
+name="hostid_save"
+start_cmd="hostid_save"
+stop_cmd=":"
+rcvar="hostid_enable"
+
+hostid_save()
+{
+ if [ ! -r ${hostid_file} ]; then
+ $SYSCTL_N kern.hostuuid > ${hostid_file}
+ if [ $? -ne 0 ]; then
+ warn "could not store hostuuid in ${hostid_file}."
+ fi
+ fi
+}
+
+load_rc_config $name
+run_rc_command "$1"
OpenPOWER on IntegriCloud